var path = require('path');

require.paths.unshift(path.dirname(__dirname));
require.paths.unshift(__dirname);

var http = require('http');
var https = require('https');
var Runner = require('NodeRunner').Runner;
var ServerConfig = require('config/NodeRunnerConfiguration');

/**
 * Maintains a list of all instantiated servers
 * running on various ports
 */
var Servers = [];

/**
 * The server simply defines the handlers to 
 * take care of incoming requests over HTTP or HTTPS.
 */
var Server = function() {
	this.http = http;
	this.https = https;
	this.serverOptions = ServerConfig;
	
	/**
	 * Handles incoming HTTP requests. Server logic
	 * should go here...
	 */
	this.httpHandler = function(request, response) {
		response.write("HTTP Server");
		response.end();
	};
	
	/**
	 * Handles incoming HTTPS requests. Server logic
	 * should go here...
	 */
	this.httpsHandler = function(request, response) {
		response.end("HTTPS Server");
	};
	
	/**
	 * Receives the created server object as well as 
	 * the hostname:port data in the event you need
	 * that data when maintaining references to the
	 * instantiated servers
	 */
	this.onCreateHandler = function(server, info) {
		Servers.push(server);
	};
	
	return this;
};

Runner.run(new Server());
